// ReadCDTextDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ReadCDText.h"
#include "ReadCDTextDlg.h"
#include "Ntddcdrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

const TCHAR* Genere_Descriptions[] = {
	// Genres start at 1 so need extra dummy at top
	_T("Dummy"),
	_T("Unknown"),
	_T("Adult Contemporary"),
	_T("Alternative Rock"),
	_T("Children's"),
	_T("Classical"),
	_T("Contemporary Christian"),
	_T("Country"),
	_T("Dance"),
	_T("Easy Listening"),
	_T("Erotic"),
	_T("Folk"),
	_T("Gospel"),
	_T("Hip Hop"),
	_T("Jazz"),
	_T("Latin"),
	_T("Musical"),
	_T("New Age"),
	_T("Opera"),
	_T("Operetta"),
	_T("Pop"),
	_T("Rap"),
	_T("Reggae"),
	_T("Rock"),
	_T("Rhythm and Blues"),
	_T("Sound Effects"),
	_T("Soundtrack"),
	_T("Spoken Word"),
	_T("World Music")
};

// CAboutDlg dialog used for App About
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()

// CReadCDTextDlg dialog
CReadCDTextDlg::CReadCDTextDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CReadCDTextDlg::IDD, pParent)
	, m_csDiscname(_T(""))
	, m_csDiscGenre(_T(""))
	, m_csDiscUPCEAN(_T(""))
	, m_csDiscIdentifier(_T(""))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_nGenreCode = -1;
}

void CReadCDTextDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_DRIVELIST, m_cDriveList);
	DDX_Control(pDX, IDC_TRACKLIST, m_cTrackList);
	DDX_Text(pDX, IDC_DISC_NAME, m_csDiscname);
	DDX_Text(pDX, IDC_DISC_GENRE, m_csDiscGenre);
	DDX_Text(pDX, IDC_DISC_UPC_EAN, m_csDiscUPCEAN);
	DDX_Text(pDX, IDC_DISC_IDENTIFIER, m_csDiscIdentifier);
}

BEGIN_MESSAGE_MAP(CReadCDTextDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_READ_CD_TEXT, &CReadCDTextDlg::OnBnClickedReadCDTextInfo)
	ON_CBN_SELCHANGE(IDC_DRIVELIST, &CReadCDTextDlg::OnCbnSelchangeDrivelist)
END_MESSAGE_MAP()


// CReadCDTextDlg message handlers

BOOL CReadCDTextDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty()) {
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	m_cTrackList.SetExtendedStyle(LVS_EX_FULLROWSELECT |LVS_EX_INFOTIP | LVS_EX_FLATSB | LVS_EX_GRIDLINES);
	m_cTrackList.ModifyStyle(NULL,LVS_NOSORTHEADER | LVS_SINGLESEL | LVS_SHOWSELALWAYS,0);
	// Insert the columns.
	m_cTrackList.InsertColumn(0, _T("Track"), LVCFMT_LEFT, 40);
	m_cTrackList.InsertColumn(1, _T("Name"), LVCFMT_LEFT, 150);
	m_cTrackList.InsertColumn(2, _T("Performer"), LVCFMT_LEFT, 100);
	m_cTrackList.InsertColumn(3, _T("Songwriter"), LVCFMT_LEFT, 100);
	m_cTrackList.InsertColumn(4, _T("Composer"), LVCFMT_LEFT, 100);
	m_cTrackList.InsertColumn(5, _T("Arranger"), LVCFMT_LEFT, 100);
	m_cTrackList.InsertColumn(6, _T("Messages"), LVCFMT_LEFT, 150);
	m_cTrackList.InsertColumn(7, _T("Code"), LVCFMT_LEFT, 100);
	m_cTrackList.InsertColumn(8, _T("Reserved 1"), LVCFMT_LEFT, 100);
	m_cTrackList.InsertColumn(9, _T("Reserved 2"), LVCFMT_LEFT, 100);
	m_cTrackList.InsertColumn(10, _T("Reserved 3"), LVCFMT_LEFT, 100);
	m_cTrackList.InsertColumn(11, _T("Reserved 4"), LVCFMT_LEFT, 100);

	// Fill the combo box with CDROM type drives.
	PopulateDriveList();
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CReadCDTextDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX) {
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CReadCDTextDlg::OnPaint()
{
	if (IsIconic()) {
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
		CDialog::OnPaint();
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CReadCDTextDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

bool CReadCDTextDlg::ReadCDTextInfo(TCHAR cDrive)
{
	// Open the device (drive) that we want to affect
	CString cs;
	DWORD BytesReturned;
	CDROM_TOC Contents;

	// Attempt to open the CD player device
	cs.Format(_T("\\\\.\\%c:"),cDrive);
	HANDLE hDrive = ::CreateFile(cs, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);

	// Make sure the device was found and opened successfully
	if(hDrive == INVALID_HANDLE_VALUE || GetLastError() != NO_ERROR) {
		AfxMessageBox(_T("Cannot open the CD device... could be in use already!"));
		return false;
	}
	
	if(!DeviceIoControl(hDrive, IOCTL_CDROM_READ_TOC, NULL, 0, &Contents, sizeof(Contents), &BytesReturned, 0)) {
		AfxMessageBox(_T("Cannot open the CD device... could be in use already!"));
		CloseHandle(hDrive);
		return(false);
	}

	// MMC-3 Draft Revision 10g: Table 222 Q Sub-channel control field
	Contents.TrackData[0].Control &= 5;
	if(!(Contents.TrackData[0].Control == 0 || Contents.TrackData[0 - 1].Control == 1)) {
		AfxMessageBox(_T("Invalid CD format!"));
		CloseHandle(hDrive);
		return(false);
	}

	CDROM_READ_TOC_EX ContentsEx;
	memset(&ContentsEx, 0, sizeof(ContentsEx));
	ContentsEx.Format = CDROM_READ_TOC_EX_FORMAT_CDTEXT;
	ContentsEx.SessionTrack = 0; // Track doesn't really matter since they all have the data
	WORD nDataSize = 0; // This has to be two bytes
	// Read the contents to get the size of the actual data
	if(!DeviceIoControl(hDrive, IOCTL_CDROM_READ_TOC_EX, &ContentsEx, sizeof(ContentsEx), &nDataSize, sizeof(nDataSize), &BytesReturned, 0)) {
		AfxMessageBox(_T("Cannot open the CD device... could be in use already!"));
		CloseHandle(hDrive);
		return(false);
	}

	// The bytes are swapped so we need to switch them around
	nDataSize = ((nDataSize>>8) | (nDataSize<<8)) + sizeof(nDataSize);

	// Allocate a buffer for reading the actual CD Text data block
	char *pCDTextData = new char[nDataSize];
	memset(pCDTextData, 0, nDataSize);

	// Now read the data
	if(!DeviceIoControl(hDrive, IOCTL_CDROM_READ_TOC_EX, &ContentsEx, sizeof(ContentsEx), pCDTextData, nDataSize, &BytesReturned, 0)){
		AfxMessageBox(_T("Cannot read the CD... could be in use already!"));
		CloseHandle(hDrive);
		delete pCDTextData;
		return(false);
	}

	nDataSize = (WORD)(BytesReturned - sizeof(CDROM_TOC_CD_TEXT_DATA));
	// This is the stuff we really need.  It's an array of packs with the data (mostly text)
	CDROM_TOC_CD_TEXT_DATA_BLOCK* pCDTextBlock = ((CDROM_TOC_CD_TEXT_DATA*)(BYTE*)pCDTextData)->Descriptors;

	// As we go through the packets we'll store the strings in this array.  The strings are often in different packets and need to be 
	// concatenated together.
	CStringArray CDTextStrings[CD_TEXT_NUM_PACKS];
	for(int i = 0; i < CD_TEXT_NUM_PACKS; i++)
		CDTextStrings[i].SetSize(Contents.LastTrack + 2);
	m_nGenreCode = -1;

	// If we get 0 then there are no packets so either the player doesn't support CD-Text or there is none on the disc.
	if(nDataSize == 0)
		AfxMessageBox(_T("There is no CD Text information on this CD!"));

	// Loop through all the packets extracting the data we need.  Each packet starts with a packet type, the track number, language code, 
	// character offset, and character size.  The packets end with a 2 byte CRC.  We don't need most of this stuff to display the info.  We can get
	// the packets for any track and they'll have all the data for each track (it's duplicated).
	for( ;nDataSize >= sizeof(CDROM_TOC_CD_TEXT_DATA_BLOCK); nDataSize -= sizeof(CDROM_TOC_CD_TEXT_DATA_BLOCK), pCDTextBlock++) {
		if(pCDTextBlock->TrackNumber > Contents.LastTrack) // Track is beyond what is on the disc
			continue;
	
		// Only looking for CD Text item packets
		if((pCDTextBlock->PackType -= 0x80) >= 0x10)
			continue;
		
		// Genre is encoded with the code and the supplemental text in the same packet
		if(m_nGenreCode == -1 && pCDTextBlock->PackType == CD_TEXT_GENRE) {
			m_nGenreCode = pCDTextBlock->Text[0]*16 + pCDTextBlock->Text[1];
			CString Text = !pCDTextBlock->Unicode 
				? CString(CStringA((CHAR*)pCDTextBlock->Text+2, CD_TEXT_FIELD_LENGTH-2))
				: CString(CStringW((WCHAR*)pCDTextBlock->WText+2, CD_TEXT_FIELD_LENGTH-2));
			CDTextStrings[pCDTextBlock->PackType][0] = Text;
		}
		else {
			// Parse the text.  There could be more than one item in the text block separated by null bytes so we need to check the whole thing
			// The text is in a block of up to 12 characters.  We'll just keep adding to our buffers until we go through all of the packets.
			int nLengthRemaining = CD_TEXT_FIELD_LENGTH;
			UINT nTrack = pCDTextBlock->TrackNumber;
			UINT nOffset = 0;
			// We're at the end of text when:
			// Used up 12 chars
			// Got to a null
			// On the last track
			while(nTrack <= Contents.LastTrack && nLengthRemaining > 0 && nOffset < CD_TEXT_FIELD_LENGTH) {
				CString Text = pCDTextBlock->Unicode ?  CString(CStringW(pCDTextBlock->WText + nOffset, nLengthRemaining)) : 
					CString(CStringA((char *)pCDTextBlock->Text + nOffset, nLengthRemaining));
				 CDTextStrings[pCDTextBlock->PackType][nTrack] += Text;
				 nOffset += Text.GetLength() + 1;
				 nLengthRemaining = nLengthRemaining - Text.GetLength() - 1;
				 ++nTrack;
			}
		}
	} while (0);

	delete pCDTextData;

	// Add stuff to the dialog and list control so we can see that it works
	m_csDiscname = CDTextStrings[CD_TEXT_TITLE][0];
	m_csDiscUPCEAN = CDTextStrings[CD_TEXT_CODE][0];
	m_csDiscGenre.Format(_T("%02d - %s - %s"), m_nGenreCode, Genere_Descriptions[m_nGenreCode], CDTextStrings[CD_TEXT_GENRE][0]);
	m_csDiscIdentifier = CDTextStrings[CD_TEXT_DISC_ID][0];
	UpdateData(false);

	m_cTrackList.DeleteAllItems();

	// Track 0 is for the entire disc.
	m_cTrackList.InsertItem(0, _T("Disc"));
	m_cTrackList.SetItemText(0, 1, CDTextStrings[CD_TEXT_TITLE][0]);
	m_cTrackList.SetItemText(0, 2, CDTextStrings[CD_TEXT_PERFORMER][0]);
	m_cTrackList.SetItemText(0, 3, CDTextStrings[CD_TEXT_SONGWRITER][0]);
	m_cTrackList.SetItemText(0, 4, CDTextStrings[CD_TEXT_COMPOSER][0]);
	m_cTrackList.SetItemText(0, 5, CDTextStrings[CD_TEXT_ARRANGER][0]);
	m_cTrackList.SetItemText(0, 6, CDTextStrings[CD_TEXT_MESSAGES][0]);
	m_cTrackList.SetItemText(0, 7, CDTextStrings[CD_TEXT_CODE][0]);
	m_cTrackList.SetItemText(0, 8, CDTextStrings[CD_TEXT_RESERVED_1][0]);
	m_cTrackList.SetItemText(0, 9, CDTextStrings[CD_TEXT_RESERVED_2][0]);
	m_cTrackList.SetItemText(0, 10, CDTextStrings[CD_TEXT_RESERVED_3][0]);
	m_cTrackList.SetItemText(0, 11, CDTextStrings[CD_TEXT_RESERVED_4][0]);

	// Tracks 1-n are for the songs
	for(int nTrack = 1; nTrack < Contents.LastTrack + 1; ++nTrack) {
		CString cs;
		cs.Format(_T("%d"), nTrack);
		m_cTrackList.InsertItem(nTrack, cs);
		m_cTrackList.SetItemText(nTrack, 1, CDTextStrings[CD_TEXT_TITLE][nTrack]);
		m_cTrackList.SetItemText(nTrack, 2, CDTextStrings[CD_TEXT_PERFORMER][nTrack]);
		m_cTrackList.SetItemText(nTrack, 3, CDTextStrings[CD_TEXT_SONGWRITER][nTrack]);
		m_cTrackList.SetItemText(nTrack, 4, CDTextStrings[CD_TEXT_COMPOSER][nTrack]);
		m_cTrackList.SetItemText(nTrack, 5, CDTextStrings[CD_TEXT_ARRANGER][nTrack]);
		m_cTrackList.SetItemText(nTrack, 6, CDTextStrings[CD_TEXT_MESSAGES][nTrack]);
		m_cTrackList.SetItemText(nTrack, 7, CDTextStrings[CD_TEXT_CODE][nTrack]);
		m_cTrackList.SetItemText(nTrack, 8, CDTextStrings[CD_TEXT_RESERVED_1][nTrack]);
		m_cTrackList.SetItemText(nTrack, 9, CDTextStrings[CD_TEXT_RESERVED_2][nTrack]);
		m_cTrackList.SetItemText(nTrack, 10, CDTextStrings[CD_TEXT_RESERVED_3][nTrack]);
		m_cTrackList.SetItemText(nTrack, 11, CDTextStrings[CD_TEXT_RESERVED_4][nTrack]);
	}

	CloseHandle(hDrive);
	return true;
}

// Get a list of drives that support CD-ROM playing
bool CReadCDTextDlg::PopulateDriveList()
{
	m_cDriveList.ResetContent();

	TCHAR szDriveRoot[] = _T("x:\\");
	TCHAR cDrive;
	UINT nDriveType;
	UINT nFlags = SHGFI_DISPLAYNAME;

	DWORD nSystemDrives = GetLogicalDrives();

    // Let the use know if they don't have any drives.
	ASSERT(nSystemDrives != 0);

	// Loop through all the drives and look for CD-ROM
	for(cDrive = 'A'; cDrive <= 'Z'; cDrive++, nSystemDrives >>= 1) {
        if(!(nSystemDrives & 1))
            continue;

		// See if this is one of the drives we're looking for and add it to the combo.
		szDriveRoot[0] = cDrive;
		nDriveType = GetDriveType(szDriveRoot);

		if(nDriveType == DRIVE_CDROM) {
			// Looks like "CD Drive (D:)"
			CString cs;
			cs.Format(_T("CD/DVD ROM Drive (%c:)"),szDriveRoot[0]);
			m_cDriveList.AddString(cs);
			// Store away the drive letter so we can retrieve it later if the user
			// selects this drive.
			m_cDriveList.SetItemData(m_cDriveList.GetCount()-1,szDriveRoot[0]);
        }
	}

	// Did we add any entries?  If not, flag that we have
	// no usable drives.
	if(m_cDriveList.GetCount() >= 1) {
		m_cDriveList.SetCurSel(0);
		m_cCurrentDrive = (TCHAR)m_cDriveList.GetItemData(0);
	}
	else
		return false;
	return true;
}

void CReadCDTextDlg::OnBnClickedReadCDTextInfo()
{
	CWaitCursor wc;
	ReadCDTextInfo(m_cCurrentDrive);
}

void CReadCDTextDlg::OnCbnSelchangeDrivelist()
{
	m_cCurrentDrive = (TCHAR)m_cDriveList.GetItemData(m_cDriveList.GetCurSel());
}
