// ReadCDTextDlg.h : header file
//

#pragma once
#include "afxwin.h"
#include <winioctl.h>  
#include "afxcmn.h"

enum PacketTypes {
	CD_TEXT_TITLE,
	CD_TEXT_PERFORMER,
	CD_TEXT_SONGWRITER,
	CD_TEXT_COMPOSER,
	CD_TEXT_ARRANGER,
	CD_TEXT_MESSAGES,
	CD_TEXT_DISC_ID,
	CD_TEXT_GENRE,
	CD_TEXT_TOC_INFO,
	CD_TEXT_TOC_INFO2,
	CD_TEXT_RESERVED_1,
	CD_TEXT_RESERVED_2,
	CD_TEXT_RESERVED_3,
	CD_TEXT_RESERVED_4,
	CD_TEXT_CODE,
	CD_TEXT_SIZE,
	CD_TEXT_NUM_PACKS
};

// CReadCDTextDlg dialog
class CReadCDTextDlg : public CDialog
{
// Construction
public:
	CReadCDTextDlg(CWnd* pParent = NULL);	// standard constructor
	CComboBox m_cDriveList;

// Dialog Data
	enum { IDD = IDD_READCDTEXT_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	TCHAR m_cCurrentDrive;

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
	bool ReadCDTextInfo(TCHAR cDrive);
	bool PopulateDriveList();
	afx_msg void OnBnClickedReadCDTextInfo();
	afx_msg void OnCbnSelchangeDrivelist();

	CListCtrl m_cTrackList;
	UINT m_nGenreCode;
	CString m_csDiscname;
	CString m_csDiscGenre;
	CString m_csDiscUPCEAN;
	CString m_csDiscIdentifier;
};
